VERSION 5.00
Begin VB.Form WebApiForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Web-API DLL Test"
   ClientHeight    =   7830
   ClientLeft      =   1770
   ClientTop       =   435
   ClientWidth     =   8910
   FillColor       =   &H80000006&
   ForeColor       =   &H80000008&
   Icon            =   "WebApiForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7830
   ScaleWidth      =   8910
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton RequestUrl 
      Caption         =   "Open Re&quest"
      Height          =   370
      Left            =   7560
      TabIndex        =   5
      Top             =   650
      Width           =   1215
   End
   Begin VB.CommandButton ReplyUrl 
      Caption         =   "Open Re&ply"
      Height          =   370
      Left            =   7440
      TabIndex        =   12
      Top             =   4200
      Width           =   1335
   End
   Begin VB.TextBox host 
      Height          =   370
      Left            =   1560
      TabIndex        =   0
      Text            =   "localhost:3380"
      ToolTipText     =   "Enter Manager host for status requests, on the form ""hostname or IP:portnumber""."
      Top             =   120
      Width           =   4215
   End
   Begin VB.CommandButton ClearButton 
      Caption         =   "&Clear output"
      Height          =   370
      Left            =   7440
      TabIndex        =   14
      Top             =   4800
      Width           =   1335
   End
   Begin VB.CommandButton RefreshButton 
      Caption         =   "&Reload to output"
      Height          =   370
      Left            =   5880
      TabIndex        =   11
      Top             =   4200
      Width           =   1335
   End
   Begin VB.TextBox repFile 
      Height          =   370
      Left            =   1560
      TabIndex        =   10
      Text            =   "C:\temp\reply.txt"
      ToolTipText     =   "Enter full path to a file where the webapireply data will be written. Click ""Refresh"" to re-read client output from the file."
      Top             =   4200
      Width           =   4215
   End
   Begin VB.CommandButton ResetButton 
      Caption         =   "Reset Free-Text to Template"
      Height          =   375
      Left            =   6000
      TabIndex        =   9
      Top             =   3600
      Width           =   2655
   End
   Begin VB.CommandButton MemRequestButton 
      Caption         =   "Run Free-&Text Request"
      Height          =   375
      Left            =   1080
      TabIndex        =   8
      Top             =   3600
      Width           =   2655
   End
   Begin VB.Frame MemRequestFrame 
      Caption         =   "Free-Text Request Data"
      Height          =   2895
      Left            =   120
      TabIndex        =   20
      Top             =   1200
      Width           =   8655
      Begin VB.CheckBox checkMemRaw 
         Caption         =   "Raw"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   2400
         Width           =   735
      End
      Begin VB.TextBox request 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2055
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   3  'Both
         TabIndex        =   6
         ToolTipText     =   "Enter or paste any webapirequest into this area and click ""Run Free-Text Request""."
         Top             =   240
         Width           =   8415
      End
   End
   Begin VB.TextBox status 
      Alignment       =   1  'Right Justify
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000011&
      Height          =   370
      Left            =   5880
      Locked          =   -1  'True
      TabIndex        =   13
      Text            =   "0"
      ToolTipText     =   "Status code for last request. See the webapi.h interface specification for a list of all codes."
      Top             =   4800
      Width           =   1335
   End
   Begin VB.CommandButton FileRequestButton 
      Caption         =   "Run &File"
      Height          =   370
      Left            =   6600
      TabIndex        =   4
      Top             =   650
      Width           =   855
   End
   Begin VB.TextBox reqFile 
      Height          =   370
      Left            =   1560
      TabIndex        =   2
      Text            =   "C:\temp\request.xml"
      ToolTipText     =   "Enter the full path to a file containing webapirequest data and click ""Run File Request""."
      Top             =   650
      Width           =   4215
   End
   Begin VB.CommandButton StatusButton 
      Caption         =   "Run &Status Request"
      Height          =   370
      Left            =   5880
      TabIndex        =   1
      Top             =   120
      Width           =   2895
   End
   Begin VB.CheckBox checkFileRaw 
      Caption         =   "Raw"
      Height          =   370
      Left            =   5880
      TabIndex        =   3
      Top             =   650
      Width           =   630
   End
   Begin VB.Frame OutputFrame 
      Caption         =   "Web-API Client Output"
      Height          =   2415
      Left            =   120
      TabIndex        =   16
      Top             =   5280
      Width           =   8655
      Begin VB.TextBox output 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2055
         HideSelection   =   0   'False
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   15
         ToolTipText     =   "Reply data from the last request"
         Top             =   240
         Width           =   8415
      End
   End
   Begin VB.Label StatusLabel 
      AutoSize        =   -1  'True
      Caption         =   "Status code"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4680
      TabIndex        =   19
      Top             =   4800
      Width           =   1065
   End
   Begin VB.Label HostLabel 
      AutoSize        =   -1  'True
      Caption         =   "Status host"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   370
      Left            =   120
      TabIndex        =   17
      Top             =   120
      Width           =   975
   End
   Begin VB.Label LastStatusLabel 
      Caption         =   "Request status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   23
      ToolTipText     =   "This light will be green if the last request was successful, or red if not."
      Top             =   4800
      Width           =   1455
   End
   Begin VB.Shape StatusShape 
      BackColor       =   &H80000011&
      Height          =   375
      Left            =   3960
      Shape           =   3  'Circle
      Top             =   4800
      Width           =   375
   End
   Begin VB.Shape ActiveShape 
      BackColor       =   &H80000011&
      Height          =   375
      Left            =   1680
      Shape           =   3  'Circle
      Top             =   4800
      Width           =   375
   End
   Begin VB.Label ReplyLabel 
      AutoSize        =   -1  'True
      Caption         =   "Reply file"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   22
      Top             =   4200
      Width           =   840
   End
   Begin VB.Label ActiveLabel 
      Caption         =   "Request active"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   21
      ToolTipText     =   "This light will be green while running a request."
      Top             =   4800
      Width           =   1455
   End
   Begin VB.Label FileLabel 
      AutoSize        =   -1  'True
      Caption         =   "Request file"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   370
      Left            =   120
      TabIndex        =   18
      Top             =   650
      Width           =   1305
   End
End
Attribute VB_Name = "WebApiForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function webApiStartup Lib "webapi.dll" () As Long
Private Declare Function webApiCleanup Lib "webapi.dll" () As Long

Private Declare Function webApiSetRequestPath Lib "webapi.dll" _
    (ByVal path As String) As Long
Private Declare Function webApiSetFileDump Lib "webapi.dll" _
    (ByVal dump As Long) As Long
Private Declare Function webApiSetLogFile Lib "webapi.dll" _
    (ByVal path As String) As Long
Private Declare Function webApiSetLogLevel Lib "webapi.dll" _
    (ByVal level As Long) As Long

Private Declare Function webApiStatusRequest Lib "webapi.dll" _
    (ByVal host As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiMemRequest Lib "webapi.dll" _
    (ByVal req As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiMemRequestRaw Lib "webapi.dll" _
    (ByVal req As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiFileRequest Lib "webapi.dll" _
    (ByVal path As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiFileRequestReply Lib "webapi.dll" _
    (ByVal reqpath As String, _
     ByVal reppath As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiFileRequestRaw Lib "webapi.dll" _
    (ByVal path As String, _
     ByVal timeout As Long) As Long
Private Declare Function webApiFileRequestReplyRaw Lib "webapi.dll" _
    (ByVal reqpath As String, _
     ByVal reppath As String, _
     ByVal timeout As Long) As Long
     
Private Declare Function webApiWriteLastReply Lib "webapi.dll" _
    (ByVal path As String) As Long
Private Declare Function webApiWriteLastFault Lib "webapi.dll" _
    (ByVal path As String) As Long
    
Private gShellObj As Object
Private Const DefaultRequest As String = "<bpxml version='1.0'>" & vbCrLf _
        & " <webapirequest>" & vbCrLf _
        & "  <user sid='' />" & vbCrLf _
        & "  <client host='127.0.0.1' origin='127.0.0.1' />" & vbCrLf _
        & "  <server host='127.0.0.1:3380' />" & vbCrLf _
        & "  <service name='bphrx' entrypoint='baseVariable' />" & vbCrLf _
        & "  <requestdata format='XML'>" & vbCrLf _
        & "   <data>5</data>" & vbCrLf _
        & "  </requestdata>" & vbCrLf _
        & " </webapirequest>" & vbCrLf _
        & "</bpxml>"

Private Sub Form_Load()
    Dim rc As Long
    
    ResetStatus
    ResetActive
    
    '--- Initialize the Web-API DLL
    rc = webApiStartup
    '------------------------------
    
    status.Text = rc
    request.Text = DefaultRequest
    Set gShellObj = CreateObject("Shell.Application")
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim rc As Long
    
    '--- Close the Web-API DLL and release system resources
    rc = webApiCleanup
    '------------------------------------------------------
    Set gShellObj = Nothing
End Sub

Private Sub WriteReply()
    '--- Write the last Web-API reply --------
    webApiWriteLastReply (repFile.Text)
    '-----------------------------------------
End Sub

Private Sub WriteFault()
    '--- Write the last Web-API fault --------
    webApiWriteLastFault (repFile.Text)
    '-----------------------------------------
End Sub

Private Sub StatusButton_Click()
    Dim rc As Long
    
    EnableRequestActive
    
    '--- Run a Web-API status request (requires no input data)
    rc = webApiStatusRequest(host.Text, 90)
    '---------------------------------------------------------
    
    UpdateButtons (rc)
End Sub

Private Sub MemRequestButton_Click()
    Dim rc As Long
    
    EnableRequestActive
    
    If checkMemRaw.Value = 1 Then
        '--- Run a Web-API file request (reads XML data from the supplied filename)
        '--- This will run in "raw" mode and extract the replydata contents from the bpxml.
        rc = webApiMemRequestRaw(request.Text, 90)
        '----------------------------------------------------------------------------------
    Else
        '--- Run a Web-API memory request (reads XML data from a string)
        rc = webApiMemRequest(request.Text, 90)
        '---------------------------------------------------------------
    End If
    
    UpdateButtons (rc)
End Sub

Private Sub FileRequestButton_Click()
    Dim rc As Long
    
    If reqFile.Text = "" Then
        rc = MsgBox("Please specify a request filename first.", vbCritical, "File Request Error")
        Exit Sub
    End If
    
    EnableRequestActive
    
    If checkFileRaw.Value = 1 Then
        '--- Run a Web-API file request (reads XML data from the supplied filename)
        '--- This will run in "raw" mode and extract the replydata contents from the bpxml.
        rc = webApiFileRequestRaw(reqFile.Text, 90)
        '----------------------------------------------------------------------------------
    Else
        '--- Run a Web-API file request (reads XML data from the supplied filename)
        rc = webApiFileRequest(reqFile.Text, 90)
        '--------------------------------------------------------------------------
    End If
    
    UpdateButtons (rc)
End Sub

Private Sub ResetButton_Click()
    request.Text = DefaultRequest
    request.SetFocus
End Sub

Private Sub RefreshButton_Click()
    On Error GoTo ErrorHandler
    
    Dim LinesFromFile, NextLine As String
    Dim rc As Integer
    
    output.Text = ""
    LinesFromFile = ""
    
    Open repFile.Text For Input As #1
    Do Until EOF(1)
        Line Input #1, NextLine
        
        LinesFromFile = LinesFromFile + NextLine + vbCrLf
    Loop
    Close #1
    output.Text = LinesFromFile
    Exit Sub
ErrorHandler:
    output.Text = ""
End Sub

Private Sub ClearButton_Click()
    output.Text = ""
    ResetStatus
End Sub

Private Sub UpdateButtons(rc As Long)
    'Update status
    If rc = 0 Then
        'Set status green
        StatusShape.FillColor = vbGreen
        WriteReply
    Else
        'Set status red
        StatusShape.FillColor = vbRed
        WriteFault
    End If
    StatusShape.FillStyle = 0 'solid
    StatusShape.Refresh
    status.Text = rc

    'Update reply text
    If repFile.Text = "" Then
        ResetActive
        rc = MsgBox("Please specify a reply filename and re-try.", vbCritical, "Write Error")
        Exit Sub
    End If
    RefreshButton_Click
    
    ResetActive
End Sub

Private Sub ResetStatus()
    status.Text = 0
    'Set status to dimmed
    StatusShape.FillStyle = 1 'transparent
    StatusShape.Refresh
End Sub

Private Sub ResetActive()
    'Set active to dimmed
    ActiveShape.FillStyle = 1 'transparent
    ActiveShape.Refresh
End Sub

Private Sub EnableRequestActive()
    'Clear reply textarea
    output.Text = ""
    
    'Set active=green, status=dimmed and hide output
    ActiveShape.FillColor = vbGreen
    ActiveShape.FillStyle = 0 'solid
    ActiveShape.Refresh
    ResetStatus
End Sub

Private Sub RequestUrl_Click()
    gShellObj.Open (reqFile.Text)
End Sub

Private Sub ReplyUrl_Click()
    gShellObj.Open (repFile.Text)
End Sub
